import{MenuController}from"../menu.mjs";import{isEmpty,humanSize,truncate,cleanHTML}from"../../base/helpers.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{View,ParentView,TabbedView}from"../../view/base.mjs";import{SimpleNotification}from"../../common/notify.mjs";import{FormView}from"../../view/forms/base.mjs";import{StringInputView,SelectInputView,CheckboxInputView}from"../../view/forms/input.mjs";const E=new ElementBuilder,browserWindowDimensions=[800,1e3];class CivitAISortInputView extends SelectInputView{static defaultOptions=["Highest Rated","Most Downloaded","Newest"];static defaultValue="Highest Rated"}class CivitAITimePeriodInputView extends SelectInputView{static defaultOptions={AllTime:"All Time",Year:"This Year",Month:"This Month",Week:"This Week",Day:"Today"};static defaultValue="Month"}class CivitAISearchOptionsFormView extends FormView{static fieldSets={Sorting:{sort:{label:"Sort Method",class:CivitAISortInputView},period:{label:"Time Period",class:CivitAITimePeriodInputView}},Filters:{commercial:{label:"Only Show Models Allowing Commercial Use",class:CheckboxInputView,config:{tooltip:"Checking this box will ensure all results have at least the 'Image' commercial use status from CivitAI. Some models may additionally authorize you to distribute or modify the models, but not all - review the details on each result before making such a determination."}},nsfw:{label:"Show NSFW Models and Images",class:CheckboxInputView,config:{tooltip:"Checking this box will show <strong>NSFW (Not Safe For Work)</strong> content of a sexual or explicit nature.<br /><br /><em>Note:</em> If safety checking is enabled on a system-wide level, NSFW results will never be returned, regardless of whether or not this box is checked."}},search:{class:StringInputView,config:{placeholder:"Search by name, user, description, etc."}}}}}class CivitAIItemView extends View{static className="civit-ai-item";static maxImagesPerItem=3;static maxCharactersPerDescription=300;static maxTags=6;constructor(e,t,i){super(e),this.item=t,this.download=i}async build(){let e=await super.build(),t=this.item.modelVersions[0].name,i=E.h2().content(this.item.name),s=E.h4().content(`By ${this.item.creator.username}`),o=E.select(),a=E.div().class("versions"),n=E.div().class("flags"),r=E.div().class("tags"),l=E.p(),c=()=>{let e=this.item.modelVersions.filter((e=>e.name===t)).shift(),i=e.trainedWords,s=e.images.slice(0,this.constructor.maxImagesPerItem),o=s.map((e=>{let t=E.img().src(e.url).css({"max-width":`${(1/s.length*100).toFixed(2)}%`});return isEmpty(e.meta)||isEmpty(e.meta.prompt)||(navigator.clipboard?(t.data("tooltip",`${cleanHTML(e.meta.prompt)}<br /><em class='note'>Ctrl+Right Click to copy prompt.</em>`),t.on("contextmenu",(t=>{t.ctrlKey&&(t.preventDefault(),t.stopPropagation(),navigator.clipboard.writeText(e.meta.prompt),SimpleNotification.notify("Copied to Clipboard",1e3))}))):t.data("tooltip",cleanHTML(e.meta.prompt))),t})),n=i.map((e=>E.span().content(e))),r=e.files.map((e=>E.div().class("download").content(E.span().class("name").content(e.name),E.span().class("type").content(`${e.metadata.size||""} ${e.metadata.fp||""}`),E.span().class("format").content(e.metadata.format),E.span().class("size").content(humanSize(1e3*e.sizeKB)),E.a().content(E.i().class("fa-solid fa-download")).data("tooltip","Start Download").on("click",(t=>{this.download(e.downloadUrl,e.name)})))));a.content(E.div().class("downloads").content(...r),E.div().class("images").content(...o),E.div().class("triggers").content(...n))};if(!isEmpty(this.item.description))if(this.item.description.length<=this.constructor.maxCharactersPerDescription)l.content(this.item.description);else{let e=E.span().content(truncate(this.item.description,this.constructor.maxCharactersPerDescription)),t=E.span().content(this.item.description).hide(),i=E.a().content("Show All").on("click",(()=>{e.hide(),i.hide(),t.show()}));l.content(e,i,t)}for(let e of this.item.tags.slice(0,this.constructor.maxTags))r.append(E.span().content(e));"None"===this.item.allowCommercialUse?n.append(E.span().content("Commercial Use Disallowed")):"Image"===this.item.allowCommercialUse?n.append(E.span().content("Commercial Use Allowed (Images Only)")):"Rent"===this.item.allowCommercialUse||"Sell"===this.item.allowCommercialUse?n.append(E.span().content("Commercial Use Allowed")):console.warning(`Unknown commercial use state '${this.item.allowCommercialUse}'`),this.item.allowNoCredit?n.append(E.span().content("No Credit Required")):n.append(E.span().content("Credit Required")),this.item.allowDerivatives?n.append(E.span().content("Derivative Models Allowed")):n.append(E.span().content("Derivative Models Disallowed"));for(let e of this.item.modelVersions){let i=E.option().content(`${e.name} (${e.baseModel})`);e.name===t&&i.selected(!0),o.append(i)}return o.on("change",(e=>{t=o.val(),c()})),o.val(t),c(),e.append(i).append(s).append(n).append(r).append(l).append(o).append(a),e}}class CivitAICategoryPageView extends View{static className="page-buttons";constructor(e,t,i){super(e),this.showPrevious=t,this.showNext=i,this.onPreviousCallbacks=[],this.onNextCallbacks=[]}onNext(e){this.onNextCallbacks.push(e)}onPrevious(e){this.onPreviousCallbacks.push(e)}previousPage(){for(let e of this.onPreviousCallbacks)e()}nextPage(){for(let e of this.onNextCallbacks)e()}async build(){let e=await super.build(),t=E.button().content("Previous Page").on("click",(()=>this.previousPage())),i=E.button().content("Next Page").on("click",(()=>this.nextPage()));return this.showPrevious||t.disabled(!0),this.showNext||i.disabled(!0),e.content(t,i)}}class CivitAICategoryBrowserView extends ParentView{static inputTimeout=500;static pageSize=20;constructor(e,t,i){super(e),this.getData=t,this.download=i,this.page=1,this.query="",this.timer=null,this.options=new CivitAISearchOptionsFormView(e),this.options.onSubmit((async e=>{try{await this.runQuery(e)}catch(e){SimpleNotification.notify("Couldn't communicate with Enfugue or CivitAI. Please try again."),console.error(e)}this.options.enable()})),this.empty(),this.addChild(this.options)}async runQuery(e){this.empty(),this.addChild(this.options);let t={page:this.page};isEmpty(e.search)||(t.query=e.search),isEmpty(e.sort)||(t.sort=e.sort),isEmpty(e.period)||(t.period=e.period),!0===e.commercial&&(t.allow_commercial_use="Image"),!0===e.nsfw&&(t.nsfw=!0);for(let e of await this.getData(null,t)){let t=new CivitAIItemView(this.config,e,((...e)=>this.download(...e)));await this.addChild(t)}let i=new CivitAICategoryPageView(this.config,this.page>1,this.children.length>this.constructor.pageSize);i.onNext((async()=>{this.page++,this.options.disable(),await this.runQuery(e),this.options.enable()})),i.onPrevious((async()=>{this.page--,this.options.disable(),await this.runQuery(e),this.options.enable()})),await this.addChild(i)}async build(){let e=await super.build();return this.options.submit(),e}}class CivitAIBrowserView extends TabbedView{constructor(e,t,i){super(e),this.addTab("Checkpoints",new CivitAICategoryBrowserView(e,((...e)=>t("checkpoint",...e)),((...e)=>i("checkpoint",...e)))),this.addTab("LoRA",new CivitAICategoryBrowserView(e,((...e)=>t("lora",...e)),((...e)=>i("lora",...e)))),this.addTab("LyCORIS",new CivitAICategoryBrowserView(e,((...e)=>t("lycoris",...e)),((...e)=>i("lycoris",...e)))),this.addTab("Textual Inversion",new CivitAICategoryBrowserView(e,((...e)=>t("inversion",...e)),((...e)=>i("inversion",...e))))}}class CivitAIView extends View{static logoPath="/static/img/brand/civit-ai-logo.svg";static className="civit-ai-view";constructor(e,t,i){super(e),this.browser=new CivitAIBrowserView(e,t,i)}getDescriptionNode(){return E.div().content(E.a().href("https://civitai.com").target("_blank").content(E.img().src(this.constructor.logoPath)),E.p().content("CivitAI is the leading AI model sharing service, providing a place where creators can uploads their trained models for other users to enjoy and employ."),E.p().content(E.span().content("By downloading any models from CivitAI, you agree to their "),E.a().href("https://civitai.com/content/tos").target("_blank").content("terms of service"),E.span().content(". Please review these terms before downloading anything. Some models come with additional terms, such as disallowing sale of images derived from those models. Use the filters at the top to only search for your desired terms, or pay attention to the tags below the model's name and author.")),E.p().content(E.span().content("If you enjoy the service CivitAI provides, please consider "),E.a().href("https://civitai.com/pricing").target("_blank").content("subscribing or donating"),E.span().content(" to support free and open-source AI.")),E.p().class("center").content(E.em().class("note").content("CivitAI, the CivitAI logo, and the CivitAI 'C' icon are all &copy; CivitAI "+(new Date).getFullYear()+", all rights reserved.")))}async build(){let e=await super.build();return e.append(this.getDescriptionNode()),e.append(await this.browser.getNode()),e}}class CivitAIController extends MenuController{static menuName="Civit AI";static menuIcon="/static/img/brand/civit-ai.png";async showBrowser(){let e=(e,...t)=>this.model.get(`civitai/${e}`,...t),t=(e,t,i)=>this.download(e,t,i);isEmpty(this.browser)?(this.browser=await this.spawnWindow("CivitAI",new CivitAIView(this.config,e,t),...browserWindowDimensions),this.browser.onClose((()=>this.browser=null))):this.browser.focus()}async onClick(){this.showBrowser()}}export{CivitAIController as MenuController};
